package lab05_solutions;
public class SingleList<E extends Comparable> {
	
		private class ListNode<E> {
			private E obj;
			private ListNode<E> next;
			
			ListNode(E obj, ListNode<E> next) { 
				this.obj = obj;
				this.next = next;
			}
			
			public E getElement(){ return this.obj;}

		}
		
        private ListNode<E> head;
        private int size;

        public SingleList() {
                this.head = null;
                size=0;
        }
        
        public void makeEmpty(){
        	this.head = null; 
        	this.size=0;
        }

        public boolean isEmpty(){
            return this.size==0;
        }

        public int size() {
            return this.size;
        }

        public void insert(E obj) {
        	ListNode<E> newNode = new ListNode<E>(obj, head);
        	this.head = newNode;
    		size+=1;
        }

        public void insertLast(E obj) {
        	ListNode<E> newNode = new ListNode<E>(obj, null);
        	ListNode<E> tmp = this.head;
        	while(tmp.next!=null){
        		tmp = tmp.next;
        	}
        	tmp.next= newNode;
    		size+=1;
        }

        public void insertSorted(E obj) {
        	System.out.println("Inserting " + obj);
        	ListNode<E> newNode = new ListNode<E>(obj, null);
        	ListNode<E> tmp = this.head;
        	//if newNode data is smaller than head data
        	if(isEmpty()){
        		this.head = newNode;
        	}
        	else if( tmp.getElement().compareTo(obj)>0 ){
        		newNode.next = tmp;
        		this.head = newNode;
        	}
        	else{
        		while(tmp!=null){
        			if(tmp.next==null || tmp.next.getElement().compareTo(obj)>0 ) break;
        			tmp = tmp.next;
        		}
        		newNode.next = tmp.next;
        		tmp.next= newNode;
        	}
        	size+=1;
        }

        public void delete(E obj) {
            if (!isEmpty()) {                        
            	ListNode<E> tmp = this.head;
            	ListNode<E> prev = tmp;
            	//if first node is to be deleted
            	if(tmp.getElement().equals(obj)){
            		this.head = this.head.next;
            		size-=1;
            	}
            	else {
            		while(tmp!=null) {
	            		if(tmp.getElement().equals(obj)){
	            			prev.next = tmp.next;
	                		size-=1;                
	            			break;
	            		}
	            		prev = tmp;
	            		tmp = tmp.next;
	            	}
            	}
            }
        }
        
        public ListNode<E> findNode(E obj){
        	ListNode<E> tmp = this.head;

        	  while( tmp!=null ){
        	    if( tmp.obj.equals(obj)) 
        	      return tmp;
        	    tmp = tmp.next;
        	  }
        	  return null;

        }
        
        public boolean existsNode(E obj){
        	ListNode<E> tmp = this.head;
		
        	while( tmp!=null ){
        		if( tmp.obj.equals(obj)) 
        			return true;
        		tmp = tmp.next;
        	}
        	return false;
        }
        
       
        public void print(){
        	ListNode<E> tmp = this.head;
        	for(int i=this.size-1; i>=0; i--){
        		System.out.print(tmp.getElement() + " ");
        		tmp = tmp.next;
        	}
        	System.out.println("");
        }
        
        public static void main(String[] args){
        	/*
        	SingleList<Integer> list = new SingleList<Integer>();
        	list.insert(1);
        	list.insert(2);
        	list.insert(3);
        	list.insert(4);
        	list.insertLast(5);
        	list.print();
        	
        	list.delete(3);
        	list.print();
        	*/
        	
        	
        	SingleList<Integer> sorted_list = new SingleList<Integer>();
        	sorted_list.insertSorted(3);
        	sorted_list.print();
        	sorted_list.insertSorted(1);
        	sorted_list.print();
        	sorted_list.insertSorted(4);
        	sorted_list.print();
        	sorted_list.insertSorted(5);
        	sorted_list.print();
        	sorted_list.insertSorted(2);
        	sorted_list.print();
        	sorted_list.delete(1);
        	sorted_list.print();

        }
}
